'use strict'

const bitcoin = require('bitcoinjs-lib')
const params = {
  bitcoin: require('webcoin-bitcoin'),
  testnet: require('webcoin-bitcoin-testnet')
}

const SPVNode = require('./node.js')

function fetchUTXOs (address, opts = {}) {
  return new Promise((resolve, reject) => {
    let scanRange = opts.scanRange || 50

    let node = opts.node || SPVNode({
      network: opts.network,
      ...opts.nodeOpts
    })

    // TODO: support other address types
    let p2pkh = bitcoin.payments.p2pkh({
      address,
      network: node.bitcoinJsNetwork
    })

    node.filter(p2pkh.hash)
    node.connect()

    // TODO: add spends to set so we don't report outputs as unspent
    let spent = new Set()

    node.scan(scanRange, (tx) => {
      // TODO:
    })

    node.on('tx', (tx) => {
      // TODO
    })
  })
}

module.exports = {
  fetchUTXOs
}
